/*
 *	idma1.c - CeWFgDMA
 *
 *	HSDMȂƂāAIDMAPŎgeXgłB
 *
 *	* Mon Jan 22 19:00:00 JST 2002 Naoyuki Sawa
 *	- 1st release.
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "c33208.h"

#define plc_IO ((volatile struct c_IOtag*)0x40000)	/* c33208.hp */
char vbuff[DISP_X * DISP_Y];			/* zVRAM */
#define MSG_SIZE 16
char msg[MSG_SIZE] = "ɂ́I";		/* \郁bZ[W */
char msg_new[MSG_SIZE] = "悤Ȃ`";	/* ]郁bZ[W */

/* IDMARg[
 * * c33208.hɂ́ARg[e[u\\̂ƂāAstruct IDMA_ST_tag pӂĂ܂B
 *   Ƃ낪A̒`悭ƁA
 *	`l      0: \
 *	`l 1` 31: n[hor\tggK
 *	`l32` 49: \tggK
 *   ́Av40`l`Ă܂B
 *   S1C33209̃}jAł́A
 *	`l      0: \tggK(?)
 *	`l 1` 31: n[hor\tggK
 *	`l32`127: \tggK
 *   ́Av128`lpł邱ƂɂȂĂ܂B
 *   S1C33208209ւ̈ڍsɁA@\Ń`l̂ł傤H
 *   S1C33209ł́Astruct IDMA_ST_tag ł͂ȂAPIDMA_ST̔zƂ悳łB
 * * ܂AS1C33209̃}jAɂ́A`l0ɂēɐGĂȂ̂CɂȂ܂B
 *   ̃vOɂŁA`l0\tggKŗpł邩ǂAmFł͂łB
 *   :g܂BvłB
 * * IDMÁAgȂ`l̃Rg[QƂȂ悤Ȃ̂ŁA
 *   `l0`Kvȃ`l܂ ̔z񂾂pӂΏ[݂łB
 *   ́A`l0gȂ̂ŁAmۂ܂B
 * * Rg[́A32rbgPʂɐ񂳂ĂȂ΂܂B
 *   IDMA_ST̐擪ounsigned intȂ̂ŁAɎw肵ȂAIɂȂ͂łB
 * * c33208.hIDMA_ST`ɁAԈႢB
 *	union {
 *		volatile struct {
 *			unsigned int	TC	: 24;	^ Data transfer counter ^
 *			unsigned int	LINKCHN	: 7;	^ IDMA link field ^
 *			unsigned int	LINKEN	: 1;	^ IDAM link enable ^
 *		} bBLK;
 *		volatile struct {
 *			unsigned int	BLKLEN	: 8;	^ Block size *^
 *			unsigned int	TC	: 16;	^ Data transfer counter ^
 *			unsigned int	LINKCHN	: 7;	^ IDMA link field ^
 *			unsigned int	LINKEN	: 1;	^ IDMA link enable ^
 *		} bSIN;
 *		volatile unsigned int	uiTC;
 *	} rTC;
 *   ́̕AbBLK(ubN][h)bSIN(VOEA][h)tł͂Ȃł傤B
 *   ܂AO̊ԈႢȂ̂ŁAقǉe͂܂...
 *   邽߂ɁAbBLKbSIN͎g킸AuiTC𒼐ڎgǂłB
 */
IDMA_ST idma[1];

/****************************************************************************
 *	pceAppInit
 ****************************************************************************/

void
pceAppInit()
{
	/* ʏ̏B */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

DISABLE;
	/*** IDMAŜ̐ݒ ***/

	/* IDMAmɒ~܂B
	 * A쒆ƁAx[XAhXݒł܂B
	 */
	IDMAEN_DISABLE;

	/* IDMARg[̃x[XAhXݒ肵܂B */
	pIDMA_DBASE = (int)&idma[0];

	/* IDMA܂B
	 * ܂Rg[̓e͐ݒ肵Ă܂񂪁A
	 * sӂ̃^C~OIDMA`lNȂƂ炩Ȃ̂ŁAŋĂ܂ĂvłB
	 * IDMALȏԂłĂ͂ȂƂ́Ax[XAhX̐ݒ肾łB
	 * Ή`lNĂȂ΁AIDMÂ͗LȂ܂܂ŃRg[ݒ肵Ă\܂B
	 * ASĐݒ肵ĂIDMAEN_ENABLEmł͂܂A
	 * ƂāAIDMAEN_ENABLȄԂŃRg[ݒł邱ƂmF邽߁A߂IDMAEN_ENABLEĂ݂܂B
	 */
	IDMAEN_ENABLE;

	/*** IDMA`l0̐ݒ ***/

	/* HSDMAł́AgKvWX^ݒ肷Kv܂B
	 * IDMAł́Ãn[hgKŋN`l(\tggK\)ƁA\tggKp̃`l
	 * `lԍɂČ܂ĂāAύXł܂B
	 * ]āAIDMAł́AgKvɊւݒ͕Kv܂B
	 */

	/* N(Ȃ)A]TCYݒ肵܂B */
	idma[0].rTC.uiTC = MSG_SIZE;

	/* 荞(Ȃ)A]P(oCg)A]AhX()A]AhXݒ肵܂B */
	idma[0].rSRC.uiSRC = (3 << 28) | (int)msg_new;

	/* ][h(A)A]AhX()A]AhXݒ肵܂B */
	idma[0].rDST.uiDST = (1 << 30) | (3 << 28) | (int)msg;

	/* HSDMAƂ́AŔÔ߂ɃgKNAsĂ܂B
	 * P/ECEł́AIDMAgĂȂ̂ŁAgKĂ邱Ƃ͂肦܂B
	 * āA̓gKtÕNAs܂łB
	 * gKtÕNAsȂAIDMAEN_ENABLȆOōsȂ΂܂B
	 * gKtÕNAɂ́AIDMAEN_STOP}Npł܂B
	 */
ENABLE;
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
	/* mɁAIDMA~܂B */
DISABLE;
	IDMAEN_DISABLE;
ENABLE;
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	/* 50Ă΂ꂽAI܂B */
	if(count == 50) {
		pceAppReqExit(0);
		return;
	}

	/* 25Ă΂ꂽAVbZ[W]܂B */
	if(count == 25) {
DISABLE;
		/* IDMA`l0N܂B
		 * * IDMÃ\tggKWX^R/WƂȂĂAZbgI[ɕύX邱Ƃ͂ł܂B
		 *   ɑ΂āAHSDMA̓ZbgI[ŒŁAR/WɕύXł܂B
		 *   ԈႦȂ悤ɒӁI
		 * * IDMÃ\tggKWX^gIDMANꍇÃ`l̓]I܂ŁA
		 *   \tggKWX^Ă͂܂B(}jA)
		 *   ƂƂ́A\tggKɂIDMA`l𕡐ɎgƂ͂łȂAƂƂłB
		 *   ܂ۂɂ́Ag邱Ƃ́A܂肦ȂƂ͎v܂...
		 * * \tggKɂIDMA`l̓]ƁADSTARTrbgI0ɖ߂܂B
		 */
		pIDMA_START = (1 << 7) | 0;
ENABLE;
	}

	/* bZ[W\܂B */
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetPos(40, 40);
	pceFontPrintf(msg);
	pceLCDTrans();
}
